"""
	generator ui file
	author: Yakir <Yakir_42@163.com>
	date: 2017/10/24
"""
import os
import shutil
import xml.dom.minidom

rootdir='./'
FilePostfix='.json'
UIFilesPath='../../ssgj_ui/ronglian'
UIFilePostfix='.ui'
UITempletFilePath='./templet.ui'
def isJsonFile(FileName):
 if os.path.splitext(FileName)[1]==FilePostfix:
  return True
 return False

def GetJsonFileName(FilePath):
 Pos=FilePath.index(FilePostfix)
 Src=''
 for i in range(0,Pos):
     Src+=FilePath[i]
 return Src

def UIFileJsonIsRight(FilePath):

 return True

def RemovePath(Path):
 
 Src=Path[2:len(Path)]

 return Src
 
def alter(file,old_str,new_str):
    file_data = ""
    with open(file, 'r') as f:
        for line in f:
            if old_str in line:
                line = line.replace(old_str,new_str)
            file_data += line
    with open(file,'w') as f:
        f.write(file_data)

filelist= os.listdir(rootdir)
for i in range(0,len(filelist)):
 path=os.path.join(rootdir,filelist[i])
 if os.path.isfile(path):
  if(isJsonFile(path)):
   GenerateUIFilePath=UIFilesPath+GetJsonFileName(path)+UIFilePostfix
   if(os.path.exists(GenerateUIFilePath)):
    DOMTree = xml.dom.minidom.parse(GenerateUIFilePath)
    collection = DOMTree.documentElement
    JsonList = collection.getElementsByTagName('JsonList')[0]
    JsonListString = JsonList.getElementsByTagName('string')[0]
    JsonName = GetJsonFileName(JsonListString.childNodes[0].data)
    if(GetJsonFileName(path)!=JsonName):
     alter(GenerateUIFilePath,'templet.json',RemovePath(GetJsonFileName(path))+FilePostfix)
   else:
    shutil.copy(UITempletFilePath,GenerateUIFilePath)
    DOMTree = xml.dom.minidom.parse(GenerateUIFilePath)
    collection = DOMTree.documentElement
    JsonList = collection.getElementsByTagName('JsonList')[0]
    JsonListString = JsonList.getElementsByTagName('string')[0]
  else:
   print(path+' not is ui file')
